#include <cstdio>
#include <cstring>

#define rep(i,n) for(i=0;i<n;i++)
#define repf(i,j,n) for(i=j;i<n;i++)

const char nums [][128] =
{
	"+---+"
	"|   |"
	"|   |"
	"+   +"
	"|   |"
	"|   |"
	"+---+",
	
	"    +"
	"    |"
	"    |"
	"    +"
	"    |"
	"    |"
	"    +",
	
	"+---+"
	"    |"
	"    |"
	"+---+"
	"|    "
	"|    "
	"+---+",
	
	"+---+"
	"    |"
	"    |"
	"+---+"
	"    |"
	"    |"
	"+---+",
	
	"+   +"
	"|   |"
	"|   |"
	"+---+"
	"    |"
	"    |"
	"    +",
	
	"+---+"
	"|    "
	"|    "
	"+---+"
	"    |"
	"    |"
	"+---+",
	
	"+---+"
	"|    "
	"|    "
	"+---+"
	"|   |"
	"|   |"
	"+---+",
	
	"+---+"
	"    |"
	"    |"
	"    +"
	"    |"
	"    |"
	"    +",
	
	"+---+"
	"|   |"
	"|   |"
	"+---+"
	"|   |"
	"|   |"
	"+---+",
	
	"+---+"
	"|   |"
	"|   |"
	"+---+"
	"    |"
	"    |"
	"+---+"
};

const char col[] =
" "
" "
"o"
" "
"o"
" "
" ";

const int MAX = 128;
char buff[MAX][MAX];
char line[MAX];

char getC(int n, int x, int y) {
	int i = y * 5 + x;
	return nums[n][i];
}

/***/
void precti(int pos, int* pole, int* n){
	*n = 0;
	int i,j,k,off;
	switch(pos) {
		case 0: off = 0;
			break;
		
		case 1: off = 5+2;
			break;
		
		case 2: off = 2*5+2*2;
			break;
		case 3: off = 17;
			break;
		case 4: off = 17+7;
			break;
		
	};
	
	if(pos == 2){
		rep(i,7)
		{
			if(buff[i][off]=='.') {
				
			} else {
				if(buff[i][off] != col[i]) {
					*n = 0; //ambiguous
					return;
				}
			}
			*n = 1;
		}
	}
	else{
		rep(k,10){ //pres secka numera
			bool muzeByt = true;
			rep(i,7){
				rep(j,5){
					if(!muzeByt) break;
					if(buff[i][off+j] == '.'){
					}
					else{
						if(buff[i][off+j] != getC(k,j,i)){
							muzeByt = false;
							break;
						}
					}
				}
			}
			if(muzeByt) {
				pole[*n] = k;
				(*n)++;
			}
		}
	}
}


void clrBuff() {
	int i,j;
	rep(i,MAX)
		rep(j,MAX)
			buff[i][j] = ' ';
}
void printBuff(){
	int i,j;
	rep(i,7){
		rep(j,29){
			printf("%c",buff[i][j]);
		}
		printf("\n");
	}
	printf("\n");
	printf("\n");
}

void printArr(int * arr, int l) {
	int i,j;
	rep(i,l) printf("%d,",arr[i]);
	printf("\n");
}
bool contains(int * pole,int l, int n){
	int i;
	rep(i,l){
		if(pole[i] == n) return true;
	}
	return false;
}

int main(int argc, char* argv[])
{
	while(1) {
		clrBuff();
		//~ printBuff();
		int i,j,k;
		gets(line);
		//~ printf("%s\n",line);
		if(strcmp(line,"end") == 0){ break;}
		rep(i,29) {
			buff[0][i] = line[i];
		}
		rep(j,6) {
			gets(line);
			//~ printf("%s\n",line);
			rep(k,29)
				buff[j+1][k] = line[k];
			
		}
		scanf("\n");
		scanf("\n");
		printBuff();
		int mozn[8][16];
		int n[8];
		rep(i,8)
			rep(j,16)
				mozn[i][j] = -1;
		rep(i,8) n[i] = 0;
		rep(i,5){
			precti(i, mozn[i], &(n[i]));
		}
		rep(i,5) {
			if(i==2) continue;
			printArr(mozn[i],n[i]);
		}
		printArr(n,5);
		
		bool amb = false;
		rep(i,5) {
			if(amb) break;
			if(n[i] <= 0) {
				amb = true;
				break;
			}
			switch(i){
				case 0: if(mozn[0][0]>2) amb = true;
					break;
				case 1: if(contains(mozn[0],n[0],2)){
						if(mozn[1][0]>4) amb = true;
					}
					break;
				case 2: break;
				case 3: if(mozn[3][0]>5) amb = true;
					break;
				case 4: break;
			}
			
			//~ printArr(mozn[i],n[i]);
		}
		if(amb) {
			printf("ambiguous\n");
		}
		
	}
	return 0;
}